#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, q;
    cin >> n >> q;
    vector<int>a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < q; i++){
        int l, r;
        cin >> l, r;
        l--; r--;
        vector<int> b(1000000000, 0);
        for(int i = l; i < r; i++){
            b[a[i]]++;
        }
        auto it = max_element(b.begin(), b.end());
        int max = *it;
        cout << max << '\n'; 
    }
    return 0;
}